Description
Given n
balloons, indexed from 0
to n-1
. Each balloon is painted with a number on it represented by array nums
. You are asked to burst all the balloons. If the you burst balloon i
you will get nums[left] * nums[i] * nums[right]
coins. Here left
and right
are adjacent indices of i
. After the burst, the left
and right
then becomes adjacent.
Find the maximum coins you can collect by bursting the balloons wisely.
Note:
(1) You may imagine nums[-1] = nums[n] = 1
. They are not real therefore you can not burst them.
(2) 0 ≤ n
≤ 500, 0 ≤ nums[i]
≤ 100
Example:
Given [3, 1, 5, 8]
Return 167
nums = [3,1,5,8] --> [3,5,8] --> [3,8] --> [8] --> []
coins = 3 * 1 * 5 + 3 * 5 * 8 + 1 * 3 * 8 + 1 * 8 * 1 = 167
Credits:
Special thanks to @dietpepsi for adding this problem and creating all test cases.
Solution
Divide and Conquer, time O(n ^ 3), space O(n ^ 2)
脑洞大开的一道题,正着不行反着想。
Be Naive First
When I first get this problem, it is far from dynamic programming to me. I started with the most naive idea the backtracking.
We have n balloons to burst, which mean we have n steps in the game. In the i th step we have n-i balloons to burst, i = 0~n-1. Therefore we are looking at an algorithm of O(n!). Well, it is slow, probably works for n < 12 only.
Of course this is not the point to implement it. We need to identify the redundant works we did in it and try to optimize.
Well, we can find that for any balloons left the maxCoins does not depends on the balloons already bursted. This indicate that we can use memorization (top down) or dynamic programming (bottom up) for all the cases from small numbers of balloon until n balloons. How many cases are there? For k balloons there are C(n, k) cases and for each case it need to scan the k balloons to compare. The sum is quite big still. It is better than O(n!) but worse than O(2^n).
Better idea
We then think can we apply the divide and conquer technique? After all there seems to be many self similar sub problems from the previous analysis.
Well, the nature way to divide the problem is burst one balloon and separate the balloons into 2 sub sections one on the left and one one the right. However, in this problem the left and right become adjacent and have effects on the maxCoins in the future.
Then another interesting idea come up. Which is quite often seen in dp problem analysis. That is reverse thinking
. Like I said the coins you get for a balloon does not depend on the balloons already burst. Therefore instead of divide the problem by the first balloon to burst, we divide the problem by the last balloon to burst.
Why is that? Because only the first and last balloons we are sure of their adjacent balloons before hand!
For the first we have nums[i-1]nums[i]nums[i+1] for the last we have nums[-1]nums[i]nums[n].
OK. Think about n balloons if i is the last one to burst, what now?
We can see that the balloons is again separated into 2 sections. But this time since the balloon i is the last balloon of all to burst, the left and right section now has well defined boundary and do not affect each other! Therefore we can do either recursive method with memoization or dp.
Final
Here comes the final solutions. Note that we put 2 balloons with 1 as boundaries and also burst all the zero balloons in the first round since they won’t give any coins.
The algorithm runs in O(n^3) which can be easily seen from the 3 loops in dp solution.
class Solution {
public int maxCoins(int[] nums) {
if (nums == null || nums.length == 0) {
return 0;
}
int n = 1;
int[] positiveNums= new int[nums.length + 2];
for (int x : nums) {
if (x == 0) { // remove zeros from nums because it doesn't earn coins
continue;
}
positiveNums[n++] = x;
}
positiveNums[0] = 1;
positiveNums[n++] = 1;
int[][] maxCoins = new int[n][n];
return maxCoinsRecur(positiveNums, 0, n - 1, maxCoins);
}
// left and right are non-exclusive boundries
public int maxCoinsRecur(int[] nums, int left, int right, int[][] maxCoins) {
if (left + 1 == right) {
return 0;
}
if (maxCoins[left][right] > 0) {
return maxCoins[left][right];
}
for (int i = left + 1; i < right; ++i) {
int coins = nums[left] * nums[i] * nums[right]
+ maxCoinsRecur(nums, left, i, maxCoins)
+ maxCoinsRecur(nums, i, right, maxCoins);
maxCoins[left][right] = Math.max(maxCoins[left][right], coins);
}
return maxCoins[left][right];
}
}
DP, time O(n ^ 3), space O(n ^ 2)
根据上面的思路,可以将其轻松转换成DP。需要注意的是DP计算的顺序,由于可能依赖中间的计算结果,DP需要按照步长有小到大计算,才能保证子问题已经被处理过。
class Solution {
public int maxCoins(int[] nums) {
if (nums == null || nums.length == 0) {
return 0;
}
int n = 1;
int[] positiveNums= new int[nums.length + 2];
for (int x : nums) {
if (x == 0) { // remove zeros from nums because it doesn't earn coins
continue;
}
positiveNums[n++] = x;
}
positiveNums[0] = 1;
positiveNums[n++] = 1;
int[][] maxCoins = new int[n][n];
for (int step = 2; step < n; ++step) {
for (int left = 0; left < n - step; ++left) {
int right = left + step;
for (int i = left + 1; i < right; ++i) {
int coins = positiveNums[i] * positiveNums[left] * positiveNums[right]
+ maxCoins[left][i] + maxCoins[i][right];
maxCoins[left][right] = Math.max(maxCoins[left][right], coins);
}
}
}
return maxCoins[0][n - 1];
}
}